Redmine - Patch #4776

Totals for Estimated Time
2010-02-09 08:25 - Ewan Makepeace

Status: Closed Start date: 2010-02-09
Priority: Normal Due date:

Assignee: % Done: 50%
Category: Issues Estimated time: 0.00 hour
Target version:

Description

We use the estimated time field extensively to both manage our work and reward our developers. We have developed two patches
for Redmine that | find indispensible. One was previously posted and | thought had been accepted into the trunk, but does not seem
to be there in 0.9. The other we have created to improve the (fantastic) new 'Group By' functionality.

The older patch gives Total Estimated Time for all issues on the page, and all issues across all pages, at the bottom of all issue lists:

total.jpg
The second provides a total of the estimated times of issues in a sub group:

grouptotal.jpg
We are not a Ruby shop - the code can probably be improved. If so please post back here!

PS: | tried to post a patch here once before and it was an embarrassing failure. Apologies in advance if this does not work out again!

Related issues:

Related to Redmine - Feature #1561: Totals for estimated/spent time and numer... Closed 2008-07-02
Related to Redmine - Feature #6571: Totalise numeric columns Closed 2010-10-05
Related to Redmine - Feature #8559: Sum columns in reports Closed 2011-06-07
Follows Redmine - Patch #2268: Patch to show Total Estimated Time at the bott... Closed 2008-12-03
History

#1 - 2010-11-22 15:24 - Victor Sergienko
- File subtotal-decimal.png added

Thank you a lot!

What version is the for? TotalEstimatedTime.patch didn't apply to my 1.0.3 (2010-10-31), though sumEstimatedTimeByGroup.patch did.
| also got a rounding bug from somewhere, see subtotal-decimal.png attachment. | don't have such a fractional estimations :)

#2 - 2010-11-23 05:08 - Ewan Makepeace

- File sumEstimatedTimeByGroup.patch added
- File totalTime.patch added

| believe this is our latest version, running on 1.0.2.
Let me know if it still gives errors.

#3 - 2011-01-28 15:39 - Victor Sergienko

May | ask you one more thing? On Redmine 1.1, with subtasks, it counts subtasks' hours alongside with parent's, so a subtask gets counted twice.
Can you please exclude issues with nonempty children?
Thanks.

#4 - 2011-02-19 06:41 - Ewan Makepeace

| know - it is a real pain. We are looking to update as you suggest. Will advise here.

#5 - 2011-04-19 14:40 - RedminePro Yang
- File estimated_hour_exclude_parent.diff added

- % Done changed from 0 to 50
With the attached patch, the parent task is excluded when sum the estimated hours for both current page and all pages.

#6 - 2011-04-29 02:14 - Ewan Makepeace

+1

We are using this to exclude parents from totals on current page, all pages and group totals. Note however that it does not (I think) exclude parents
from CSV listings ect.

#7 - 2011-05-05 09:48 - David Marin Carreiio

+1
Please, get this functionality into the main trunk.

#8 - 2011-05-06 15:44 - Terence Mill

+1 FOR..

Calculated fields can be optionally switched on per poeject and tracker and field.
...calculation can be

sum

average

max
min

...Calculcated values can be shown for

¢ atask (included subtash ) in issue form, e.g at the bottom
¢ issue list as summary for filtered issues (mean same values on every page if search result is splitted on several result pages)

¢ on issue list group level a total for every group
We would need that for estimation and spent time and total numer of issues for a group

#9 - 2011-09-05 10:16 - pasquale [:dedalus]

+1

#10 - 2011-09-05 12:58 - Terence Mill
+1

Please include this!

Totals for all number type fields on group header/footer is fundamental requirement here.

#11 - 2011-09-05 13:12 - Jérome BATAILLE

+1

#12 - 2011-10-26 06:14 - Mischa The Evil

As mentioned the first time by Tony Marschall in #8559 note-4, there exists a plugin which provides (parts of) this feature (along with some others):
Redmine spent time column. It's written by Jan Schulz-Hofen of plan.io.

I've started working on some improvements to make it better suitable for this issue in my fork of it:
https://github.com/MischaTheEvil/redmine_spent_time_column

#13 - 2011-11-11 10:08 - Matej Kenda

| vote for inclusion of this patch into the release 1.2.2.

#14 - 2011-11-11 14:54 - Giovani Spagnolo

+1

#15 - 2011-11-13 10:00 - Terence Mill

+1

#16 - 2011-11-14 21:03 - Matej Kenda
Matej Kenda wrote:

| vote for inclusion of this patch into the release 1.2.2.

Or 1.2.3 since 1.2.2 was just released.

#17 - 2012-03-30 16:58 - Nicolas Ottavi
Hi,

My two cents, | am not a redmine export nor a ruby developer at all, but | was wondering if adding function which return the total estimation time in the
project Model would not be a good solution. This way we could use this value anywhere in redmine where projects are listed ?

def estimated_duration
issues.sum(:estimated_hours, :include => [:status, :project], :conditions => Issue.merge_conditions(nil,
"#{Issue.table_name}.rgt - #{Issue.table_name}.lft = 1")
rescue ::ActiveRecord::StatementInvalid => e
raise StatementInvalid.new(e.message)
end

#18 - 2012-07-25 15:48 - strexy strexy

Hello everybody,
is this useful patch compatible with Redmine 0.9.3 stable ?

Thanks in advance.

#19 - 2012-07-25 17:59 - Ewan Makepeace

We are currently running 1.3 and | could not use redmine without these group and running totals. However the first attached version of the patch was
written for 0.9 so | think there is a good chance it would run with 0.9.3

#20 - 2012-08-01 02:30 - strexy strexy

Hi all,
on my 0.9.3 I've successfully installed the TotalEstimatedTime.patch but the very useful sumEstimatedTimeByGroup.patch generates an error as | try
to group a tasks list.

It seems that this
<%= @issue_sum_by_group[group] %> (line 22 of views/issues/_list.rhtml)
is not compatible for whatever reason.

It's declared in models/query.rb

#Returns sum of the issue's estimated_hours by group or nil if query is not grouped

def issue_sum_by_group

r = nil

if grouped?

begin

r = Issue.sum(:estimated_hours, :group => group_by_statement, :include => [:status, :project], :conditions => statement)
rescue ActiveRecord::RecordNotFound

r={r => issue_sumy}

end

¢ = group_by_column

if c.is_a?(QueryCustomFieldColumn)

r = r.keys.inject({}) {|h, k| h[c.custom_field.cast_value(k)] = r[k]; h}
end

end

r

rescue ::ActiveRecord::Statementinvalid => e

raise Statementlnvalid.new(e.message)

end

Maybe someone have already solved this issue.
I'm not a coder at all.
Thanks in advance.

#21 - 2012-08-02 17:48 - Bill Wang

the error msg?

#22 - 2012-08-09 18:37 - strexy strexy

2025-05-02 3/8



ActionView::TemplateError (undefined method []' for nil:NilClass) on line #22 of app/views/issues/_list.rhtml:

19:  <tr class="group open">

20: <td colspan="<%= query.columns.size + 2 >">

21: <span class="expander" onclick="toggleRowGroup(this); return false;"> </span>

22: <= group.blank? ? 'None' : column_content(@query.group_by_column, issue) > <span class="count">(<= @issue_sum_by_group[group]
>)</span>

23: </td>

24: </tr>

25: < previous_group = group %>

#23 - 2012-08-10 08:58 - Bill Wang

hi strexy, it means @issue_sum_by_group is nil.

S0, maybe:
1. check whether you missed something.

——— app/controllers/issues_controller.rb (revision 4884)
+++ app/controllers/issues_controller.rb (working copy)
@@ -85,7 +85,8 @@

:order => sort_clause,

:offset => Qoffset,

:limit => Q@limit)

@issue_count_by_group = @Qquery.issue_count_by_group
+ @issue_count_by_group = (@query.issue_count_by_group
+ @issue_sum_by_group = @query.issue_sum_by_group
2.
+ # Returns sum of the issue's estimated_hours by group or nil if query is not grouped
+ def issue_sum_by_group
+ r = nil
+ if grouped?
+ begin
+ r = Issue.sum(:estimated_hours, :group => group_by_statement, :include => [:status, :project],
+ :conditions => Issue.merge_conditions (statement , "#{Issue.table_name}.rgt - #{Issue.table_name}.lft
=1"))
+ rescue ActiveRecord::RecordNotFound
+ r= {r => issue_sum}
+ end
+
+ c = group_by_column
+ if c.is_a? (QueryCustomFieldColumn)
+ r = r.keys.inject ({}) {lh, k| hl[c.custom_field.cast_value(k)] = r[k]; h}
+ end
+ end
+ r
+ rescue ::ActiveRecord::StatementInvalid => e
+ raise StatementInvalid.new(e.message)
+ end
+

maybe because of "nil if query is not grouped".
however, accodring to my testing in my redmine, it will not go that line code if not groupd.

<% 1f Qquery.grouped? && (group = @query.group_by_column.value (issue)) != previous_group %> <--it means h
as_groupd and this_groupd is not equal to previous_group.
so | guess you missed something.

#24 - 2012-08-10 10:21 - strexy strexy

Thanks Bill,
for sure I've missed something.

As you said, it didn't worked only when grouped.
I'll check it after my vacations.

I'll let you know.
Thanks.
#25 - 2013-07-15 09:35 - michel p
Hi,
I try to use the patch... without even know how to code "hello world" with ruby :)

Can someone is able to convert the ":conditions => Issue.merge_conditions(statement..." with scope ?
| use version 2.3.1 and merge_condition seems an deprecated way to do the stuff

thx

#26 - 2013-07-15 14:33 - michel p
UPDATE:

it seems that works with this patch:

-:conditions => Issue.merge_conditions(statement , "#{Issue.table_name}.rgt - #{Issue.table_name}.Ift = 1"))
+:conditions => [(statement), ("#{Issue.table_name}.rgt - #{Issue.table_name}.Ift = 1")])

there is 2 lines like this in the patch
I'm not sure that this kind of code is correct so if a ruby coder can produce a valid patch for rails 3 it would be better
Hope that can help

#27 - 2013-10-17 13:22 - Olivier Houdas
- File estimatedTime.diff added

It almost did it, but actually created an issue for filters which use the Contains operator.

Indeed, that filtering operator results in conditions like "WHERE LOWER LIKE '%test%", which raised the error : "ActionView::Template::Error (invalid
format character - %):" when using the array.

| have changed it to

-:conditions => Issue.merge_conditions(statement , "#{Issue.table_name}.rgt - #{Issue.table_name}.Ift = 1"))

+:conditions => statement << "AND #{Issue.table_name}.rgt - #{Issue.table_name}.Ift = 1")

which seems to work.

I'm attaching the .diff file for Redmine 2.3.3 to help even more.
Note that in addition to that change, | slightly modified the text displayed in this version, so that it indicates "estimated time : xx hours" instead of just a
number.
The patch contains a hardcoded string for the end of page summary ("current page"), | did not change that.
#28 - 2013-12-04 10:42 - nicola mondinelli
Olivier Houdas wrote:
I'm attaching the .diff file for Redmine 2.3.3 to help even more.
Note that in addition to that change, I slightly modified the text displayed in this version, so that it indicates "estimated time : xx hours" instead of

just a number.

The patch contains a hardcoded string for the end of page summary ("current page"), | did not change that.

Oliver, i spotted a issue in the patch: on grouping on custom field i've got a 500 error:

Query::StatementInvalid: Mysqgl2::Error: Unknown column 'cf_5.value' in 'field list': SELECT SUM( issues . esti

mated_hours') AS sum_estimated_hours, COALESCE (cf_5.value, '') AS coalesce_cf_5_value FROM " issues’ LEFT OUTER
JOIN "issue_statuses’ ON “issue_statuses . id’ = “issues’ . status_id' LEFT OUTER JOIN "“projects’ ON "“projects
T.7id’ = “issues’ . project_id' WHERE ((issues.status_id IN (SELECT id FROM issue_statuses WHERE is_closed=0))

AND projects.id = 15 AND issues.rgt - issues.lft = 1) GROUP BY COALESCE (cf_5.value, '')

#29 - 2014-01-16 09:42 - Olivier Houdas
- File estimatedTime-v2.dif added

True, Nicola. | fixed it in this patch: estimatedTime-v2.dif
#30 - 2014-01-20 20:15 - Jessica Berriman

I'm trying to install this plugin/patch to our Redmine configuration (4.2 on Windows), but I'm admittedly new to Redmine and am not sure how to get
this functionality installed.

2025-05-02 5/8



Could anyone provide guidance for this?
Much appreciated in advance!

#31 - 2014-01-20 20:36 - Jan from Planio www.plan.io

This tracker is for Redmine bugs/features/patches only. To request guidance, please ask in the forums. Thanks!

#32 - 2014-05-07 22:10 - Oscar Corsvall

Does this patch work with redmine 2.5.0?

#33 - 2014-05-08 02:44 - Ewan Makepeace

We are still on Redmine 2.0.3.devel. 10073 - | am surprised we have got so far behind, | need to check what is new in Redmine!

#34 - 2014-05-23 16:14 - Olivier Houdas
| did upgrade sucessfully with this code (estimatedTime-v2.dif ) to 2.4.3. | haven't upgraded to 2.5.1 yet.

#35 - 2015-06-24 14:41 - Artem Karamov

Can anybody confirm if this nice patch work with redmine 3.0.3?

#36 - 2015-06-24 19:34 - Olivier Houdas

- File Redmine.org-4776-Estimated time patch for RM 3.0.3.patch added

It does not: some code was moved to a helper file between 2.6 and 3.0.

You will find attached the patch of our changes on 3.0.3.

It also includes displaying spent time subtotals for grouped queries.

Note that when parents tasks are shown with their children in the same group, the spent time is counted twice. | haven't found out how to fix that issue
so far.

| also haven't found how to manage to get spent time when the issues are grouped by project.

| don't guarantee the quality of the code, as I'm pretty new to Ruby... remarks / improvements are welcome!
#37 - 2015-06-25 11:22 - Olivier Houdas

- File RM3.0.3-Estimated-and-spent-times.png added

For those interested, here is a screenshot of how we use the patch.
We manage our Agile sprints on Redmine, and this query filters on one sprint, grouping test tasks per product.
We group by tester to ensure the load is evenly spread, and by product to inform product owners about the planned test efforts.

#38 - 2015-06-25 12:42 - Ewan Makepeace

It seems we have a couple of issues covering the same issue. We recently posted our current patch version on this issue #2268 but not here.

No change in functionality - just tracking redmine changes, | am completely unsure how that code and the code describes here differs.

#39 - 2015-06-29 10:38 - Artem Karamov

Thank you very much, Olivier! Installed it on 3.0.3
Very useful patch for planning and review of previous sprints/versions

#40 - 2015-08-14 16:16 - Olivier Houdas
- File Redmine.org-4776-Estimated-time-patch_v1.1-for-RM-3.1.0.patch added

| fixed a case of Error 500 on the previous patch, which happens when sorting on a column selected for grouping.
Attached is the full patch with the fix, produced on Redmine 3.1.0.

#41 - 2015-09-24 23:32 - Jonathan Vargas

This worked fine for us. | just removed the unpaired parentheses at the footer of the query results. Thanks, I'm not Ruby developer, but could this
patch be a plugin instead?

#42 - 2015-12-27 05:40 - Toshi MARUYAMA

- Status changed from New to Closed

| think this issue is fixed by #1561.
If you have more request, please create new issue.

Files

total.jpg 23.4KB 2010-02-09 Ewan Makepeace
grouptotal.jpg 26.9 KB 2010-02-09 Ewan Makepeace
TotalEstimatedTime.patch 7.33 KB 2010-02-09 Ewan Makepeace
sumEstimatedTimeByGroup.patch 2.8 KB

subtotal-decimal.png 684 Bytes
sumEstimatedTimeByGroup.patch 2.79 KB
totalTime.patch 1.01 KB
estimated_hour_exclude_parent.diff 3.37 KB
estimatedTime.diff 3.41 KB
estimatedTime-v2.dif 3.54 KB
Redmine.org-4776-Estimated time patch for RM 3.0.3.patch 8.78 KB
RM3.0.3-Estimated-and-spent-times.png 57.5 KB

Redmine.org-4776-Estimated-time-patch_v1.1-for-RM-3.1.0.patch 9.71 KB
